from django.contrib import admin
from django.contrib.auth.models import Group

from two_factor.models import PhoneDevice
from django_otp.plugins import otp_totp, otp_static
from django_cron.models import CronJobLog
from django_celery_results.models import TaskResult

from .models import Organization, Device, Network, Model, Wifi, Notification

# Registering own models

admin.site.register(Organization)
admin.site.register(Device)
admin.site.register(Network)
admin.site.register(Model)
admin.site.register(Wifi)
admin.site.register(Notification)

# Unregistering unused framework models

admin.site.unregister(Group)

# Unregistering unused third-party module models

admin.site.unregister(PhoneDevice)
admin.site.unregister(otp_totp.models.TOTPDevice)
admin.site.unregister(otp_static.models.StaticDevice)
admin.site.unregister(CronJobLog)
admin.site.unregister(TaskResult)
