from django import template
from manager.models import Notification
from django.utils import timezone
from django.db.models import Q

register = template.Library()


@register.inclusion_tag('manager/notifications.html', takes_context=True)
def getNotifications(context, login=False):
    notfilter = Notification.objects.filter
    filtered = notfilter(Q(expiry__gte=timezone.now()) | Q(expiry=None))

    notifications = []

    for notification in filtered:
        if notification.on_login or not login:
            notifications.append(notification)

    if "exception" in context.dicts[3] and context.dicts[3]["exception"]:
        exception = Notification()
        exception.status = 2
        exception.text = context.dicts[3]["exception"].human
        if context.dicts[3]["user"].is_superuser:
            exception.text += (
                "<br><br><code>%s</code>" % str(context.dicts[3]["exception"])
                )
        notifications = [exception] + notifications
    return {'notifications': notifications}
