from django import template
from django.conf import settings
from git import Repo

register = template.Library()


@register.simple_tag
def getCommit():
    repo = Repo(settings.BASE_DIR)
    return "%s (%s)" % (
            str(repo.head.commit)[:7],
            str(repo.head.commit.committed_datetime)
            )


@register.simple_tag
def isLatestCommit():
    repo = Repo(settings.BASE_DIR)
    origin = repo.remotes[0].refs[0]
    if origin.commit.committed_datetime <= repo.head.commit.committed_datetime:
        return ""
    return " – Update available!"


@register.simple_tag
def isDirty():
    repo = Repo(settings.BASE_DIR)
    return " – Uncommitted changes!" if repo.is_dirty() else ""
