from django.urls import path, include

from . import views

urlpatterns = [
    path(
        '',
        views.index,
        name='index'
        ),

    path(
        'devices/',
        views.devices,
        name='devices'
        ),

    path(
        'wifi/',
        views.devices,
        name='wifi'
        ),

    path(
        'users/',
        views.devices,
        name='users'
        ),

    path(
        'networks/',
        views.devices,
        name='networks'
        ),

    path(
        'organizations/',
        views.devices,
        name='organizations'
        ),

    path(
        'hosts',
        views.hosts,
        name='hosts'
        ),

    path(
        'devices/<int:device_id>/edit/',
        views.editdevice,
        name='editdevice'
        ),

    path(
        'devices/<int:device_id>/ping/',
        views.ping,
        name="ping"
        ),

    path(
        'devices/<int:device_id>/download/',
        views.getconfig,
        name="getconfig"
        ),

    path(
        'devices/<int:device_id>/delete/',
        views.deletedevice,
        name="deletedevice"
        ),

    path(
        'devices/<int:device_id>/reboot/',
        views.rebootdevice,
        name="rebootdevice"
        ),

    path(
        'heartbeat',
        views.heartbeat,
        name='heartbeat'
        ),

    path(
        'wireless',
        views.wireless,
        name='wireless'
        ),

    path(
        'makedevice/',
        views.makedevice,
        name="makedevice"
        ),

    path(
        'makewifi/',
        views.makewifi,
        name='makewifi'
        ),

    path(
        'makeuser/',
        views.makeuser,
        name='makeuser'
        ),

    path(
        'makenet/',
        views.makenetwork,
        name='makenet'
        ),

    path(
        'makeorga/',
        views.makeorganization,
        name='makeorga'
        ),

    path(
        'networks/<int:network_id>/delete',
        views.deletenetwork,
        name='deletenetwork'
        ),

    path(
        'networks/<int:network_id>/edit',
        views.editnetwork,
        name='editnetwork'
        ),

    path(
        'wifi/<int:wifi_id>/edit/',
        views.editwifi,
        name='editwifi'
        ),

    path(
        'wifi/<int:wifi_id>/delete/',
        views.deletewifi,
        name='deletewifi'
        ),

    path(
        'users/<int:user_id>/edit/',
        views.edituser,
        name='edituser'
        ),

    path(
        'users/<int:user_id>/delete/',
        views.deleteuser,
        name='deleteuser'
        ),

    path(
        'organizations/<int:orga_id>/delete/',
        views.deleteorga,
        name='deleteorga'
        ),

    path(
        'organizations/<int:orga_id>/edit/',
        views.editorganization,
        name='editorganization'
        ),

    path(
        'update',
        views.update,
        name='update'
        ),

    path(
        'setactiveorga/<int:orga_id>/',
        views.setactiveorga,
        name='setactiveorga'
        )
]
