from django.contrib import admin
from django.urls import include, path
from django.conf.urls import url
from django.contrib.auth.decorators import login_required

from two_factor.urls import urlpatterns as tf_urls
from two_factor.gateways.twilio.urls import urlpatterns as tf_twilio_urls

admin.autodiscover()
admin.site.login = login_required(admin.site.login)
admin.site.site_header = 'VPN360 Network Administration'
admin.site.site_title = admin.site.site_header
admin.site.index_title = admin.site.site_title

urlpatterns = [
    url(r'', include(tf_twilio_urls)),
    url(r'', include(tf_urls)),
    path('', include('manager.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls'))
]

handler400 = "manager.views.handler400"
handler403 = "manager.views.handler403"
handler404 = "manager.views.handler404"
handler500 = "manager.views.handler500"
